CodeForces 887B Cubes for Masha (暴力 || DFS)

Absent-minded Masha got set of n cubes for her birthday.

At each of 6 faces of each cube, there is exactly one digit from 0 to 9. Masha became interested what is the largest natural x such she can make using her new cubes all integers from 1 to x.

To make a number Masha can rotate her cubes and put them in a row. After that, she looks at upper faces of cubes from left to right and reads the number.

The number can't contain leading zeros. It's not required to use all cubes to build a number.

Pay attention: Masha can't make digit 6 from digit 9 and vice-versa using cube rotations.

Input
In first line integer n is given (1 ≤ n ≤ 3) — the number of cubes, Masha got for her birthday.

Each of next n lines contains 6 integers aij (0 ≤ aij ≤ 9) — number on j-th face of i-th cube.

Output
Print single integer — maximum number x such Masha can make any integers from 1 to x using her cubes or 0 if Masha can't make even 1.

Example
Input
3
0 1 2 3 4 5
6 7 8 9 0 1
2 3 4 5 6 7
Output
87
Input
3
0 1 3 5 6 8
1 2 4 5 7 8
2 3 4 6 7 9
Output
98
Note
In the first test case, Masha can build all numbers from 1 to 87, but she can't make 88 because there are no two cubes with digit 8.

题意:

给出n个正方体,正方体的每个面上都有一个0~9的数字。正方体的排列可以任意组合,问能使数字排列从1到x的x最大是多少?(正方体可以选择不用,没有前导零且不能把6翻转当成9使用)。

题解:

因为可能组成的数字最大是999,所以用DFS找出所有能组成的数字就好了。

#include<iostream>
#include<cstring>
using namespace std;
int a[3][6];
bool used[6];
bool vis[1005];
int n;
void dfs(int num,int k)//k为当前使用的正方体数量
{
    vis[num]=true;
    if(k>=n)
        return ;
    for(int i=0;i<n;i++)
    {
        if(!used[i])
        {
            for(int j=0;j<6;j++)
            {
                used[i]=true;
                dfs(10*num+a[i][j],k+1);
                used[i]=false;//DFS回溯
            }
        }
    }
}
int main()
{
    cin>>n;
    //memset(used,false,sizeof(used));
    //memset(vis,false,sizeof(vis));
    for(int i=0;i<n;i++)
        for(int j=0;j<6;j++)
            cin>>a[i][j];
    dfs(0,0);
    for(int i=1;i<=1000;i++)
        if(!vis[i])
        {
            cout<<i-1<<endl;
            break;
        }
    return 0;
}
原文地址:https://www.cnblogs.com/orion7/p/7886731.html